function PasswordAssistant(argFromPusher) {}

PasswordAssistant.prototype = {
	setup: function() {
		Ares.setupSceneAssistant(this);

		// L10N
		this.$.pageHeader1.setTitle($L("Decrypt Database"));
		this.$.label1.setLabel($L("The database is encrypted using 160 bit blowfish encryption. Enter the current password and tap 'continue':"));
		this.$.passwordField1.setHintText($L("current password"));
		this.$.label2.setLabel($L("To change or initially set the database encryption password, enter the current password above (can be empty) and the new password twice below"));
		this.$.passwordField2.setHintText($L("new password"));
		this.$.passwordField3.setHintText($L("confirm new password"));
		this.$.button1.setLabel($L("Continue"));
	},
	cleanup: function() {
		Ares.cleanupSceneAssistant(this);
	},
	button1Tap: function(inSender, event) {
		var currentPassword = this.$.passwordField1.getValue();
		var newPassword1 = this.$.passwordField2.getValue();
		var newPassword2 = this.$.passwordField3.getValue();

		// Validate whether the entered password is correct
		// let's hope that blowfish will never be vulnerable to any known plaintext attacks
		if (settings.decryptWithKey(settings.generateKey(currentPassword), settings.getDecryptTestString()) != "decryptTestString") {
			// Show error message if password was not correct
			settings.decryptionFailedCounter++;
			if (settings.decryptionFailedCounter < 5) {
				var data={num:5 - settings.decryptionFailedCounter};
				Mojo.Log.info("Login failed (#{num})".interpolate(data));
				Mojo.Controller.errorDialog($L("The provided password is not correct. You have #{num} attempts left before database is erased.").interpolate(data));
			} else {
				// Erase database
				Mojo.Controller.errorDialog($L("Too many attempts with a wrong password. The database has been erased, the current password is empty."));
				Mojo.Log.info("Database erased");

				settingsCookie.put({}); // Erase database
				settings = new Settings(); // init with default
			}
		} else {
			// Decryption was successful -> password was good
			// Return to main and handle the "change password" use case only if decryption was successful
			settings.setKey(currentPassword);
			settings.decryptionFailed = false;
			Mojo.Log.info("Login successful");

			// Do we also want to change the password?
			if (newPassword1.length > 0 || newPassword2.length > 0) {
				if (newPassword1 == newPassword2) {
					// Change the password:
					settings.setKey(newPassword1);

					// Step 1: re-encrypt the servers 
					// TODO: this should be moved to the model for better encapsulation!
					var serverList = settings.getServerList();
					for (var i = 0; i < serverList.length; i++) {
							var credentialsEncoded = serverList[i].value.split(",");
							serverList[i].value = credentialsEncoded[0] + "," + settings.encrypt(settings.decryptWithKey(settings.generateKey(currentPassword),credentialsEncoded[1]));
					}
					settings.setServerList(serverList);

					// Step 2: re-encrypt the last selected server
					// TODO: this should be moved to the model for better encapsulation!
					var lastSelected = settings.getLastSelectedServer().split(",");
					settings.setLastSelectedServer(lastSelected[0] + "," + settings.encrypt(settings.decryptWithKey(settings.generateKey(currentPassword),lastSelected[1])));
					
					// Step 3: re-encrypt the decryptTestString
					// TODO: this should be moved to the model for better encapsulation!
					settings.setDecryptTestString(settings.encrypt(settings.decryptWithKey(settings.generateKey(currentPassword),settings.getDecryptTestString())));

					Mojo.Log.info("Password change successful");

					// return to main / close scene
					var rc = {}; // return array is empty
					Mojo.Controller.stageController.popScene(rc);
				} else {
					Mojo.Controller.errorDialog($L("The provided passwords do not match. Type the new password in both text boxes."));
				}
			} else {
				// no password change -> return to main / close scene
				var rc = {}; // return array is empty
				Mojo.Controller.stageController.popScene(rc);
			}
		}
	}
};