function PreferencesAssistant(argFromPusher) {}

function removeByElementValue(arrayName, arrayElementValue) {
	for (var i = 0; i < arrayName.length; i++) {
		if (arrayName[i].value == arrayElementValue) {
			arrayName.splice(i, 1);
		}
	}
}

function elementLabelExist(arrayName, arrayElementLabel) {
	for (var i = 0; i < arrayName.length; i++) {
		if (arrayName[i].label == arrayElementLabel) {
			return true;
		} else {
			return false;
		}
	}
}

PreferencesAssistant.prototype = {
	setup: function() {
		Ares.setupSceneAssistant(this);

		// L10N
		this.$.pageHeader1.setTitle($L("Preferences"));
		this.$.group1.setLabel($L("Servers and Passphrases"));
		this.$.textField1.setHintText($L("server name"));
		this.$.passwordField1.setHintText($L("server master otp passphrase"));
		this.$.button1.setLabel($L("Save"));
		this.$.button2.setLabel($L("Delete"));
	},
	cleanup: function() {
		Ares.cleanupSceneAssistant(this);
	},
	activate: function(event) {
		// Load configured servers from persistency and populate model
		if (settings.getServerList().length == 0) {
			// Show a dialog:
			// http://www.weboshelp.net/getting-started-with-webos/357-webos-dialogs
			Mojo.Log.info($L("No server configured, init with default"));
			Mojo.Controller.errorDialog($L("No server configured, initalizing with default values."));

			settings.init(); // reset to default values
			settings.writeSettingsCookie(); // store
		}
		this.listSelector1Model.choices = settings.getServerList();
		this.listSelector1Model.value = settings.getLastSelectedServer();
		this.controller.modelChanged(this.listSelector1Model);
	},
	button1Tap: function(inSender, event) {
		// save the current text box content as a new server
		// TODO: this should be moved to the model for better encapsulation!
		var newLabel = this.$.textField1.getValue().toLowerCase();
		var newValue = Base64.encode(newLabel) + "," + settings.encrypt((this.$.passwordField1.getValue()));

		if (newLabel.length == 0 || this.$.passwordField1.getValue().length == 0) {
			Mojo.Controller.errorDialog($L("The changes were not saved: enter both server name and password."));
		} else {
			if (elementLabelExist(this.listSelector1Model.choices, newLabel)) {
				Mojo.Controller.errorDialog($L("The changes were not saved: a server with this name already exists."));
			} else {
				this.listSelector1Model.choices.push({
					label: newLabel,
					value: newValue
				});
				this.listSelector1Model.value = newValue;
				this.controller.modelChanged(this.listSelector1Model);

				settings.setLastSelectedServer(this.listSelector1Model.value);
				settings.setServerList(this.listSelector1Model.choices);

				Mojo.Log.info("Server added: ", this.listSelector1Model.value);

				// return to main / close scene
				var rc = {}; // return array is empty
				Mojo.Controller.stageController.popScene(rc);
			}
		}
	},
	button2Tap: function(inSender, event) {
		if (this.listSelector1Model.choices.length > 0) {
			// delete the current server
			removeByElementValue(this.listSelector1Model.choices, this.listSelector1Model.value);

			if (this.listSelector1Model.choices.length == 0) {
				// reset selector display
				this.listSelector1Model.value = "";

				// disable delete button after last server has been deleted
				this.$.button2.setDisabled(true);
			} else {
				// reset selector display
				this.listSelector1Model.value = this.listSelector1Model.choices[0].value;
			}

			// Update view
			this.controller.modelChanged(this.listSelector1Model);

			settings.setServerList(this.listSelector1Model.choices);
		}
	},
	listSelector1Change: function(inSender, event) {
		Mojo.Log.info("Server selected: ", this.listSelector1Model.value);

		settings.setLastSelectedServer(this.listSelector1Model.value);
	}
};